# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Union
from pydantic.v1 import BaseModel, Field, StrictFloat, StrictInt, conlist, constr
from lusid.models.perpetual_property import PerpetualProperty

class Strategy(BaseModel):
    """
    Strategy
    """
    keys: conlist(PerpetualProperty, min_items=1) = Field(...)
    value_type: constr(strict=True, min_length=1) = Field(..., alias="valueType")
    value: Union[StrictFloat, StrictInt] = Field(...)
    __properties = ["keys", "valueType", "value"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Strategy:
        """Create an instance of Strategy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in keys (list)
        _items = []
        if self.keys:
            for _item in self.keys:
                if _item:
                    _items.append(_item.to_dict())
            _dict['keys'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Strategy:
        """Create an instance of Strategy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Strategy.parse_obj(obj)

        _obj = Strategy.parse_obj({
            "keys": [PerpetualProperty.from_dict(_item) for _item in obj.get("keys")] if obj.get("keys") is not None else None,
            "value_type": obj.get("valueType"),
            "value": obj.get("value")
        })
        return _obj
